// D import file generated from 'derelict/devil/ilu.d'
module derelict.devil.ilu;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.devil.il;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "ilu.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libILU.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libILU.so";
			}
			else
			{
				static assert(0, "Need to implement ILU libNames for this operating system.");
			}
		}
	}
}
enum : ILenum
{
	ILU_VERSION_1_7_8 = 1,
	ILU_VERSION = 178,
	ILU_FILTER = 9728,
	ILU_NEAREST = 9729,
	ILU_LINEAR = 9730,
	ILU_BILINEAR = 9731,
	ILU_SCALE_BOX = 9732,
	ILU_SCALE_TRIANGLE = 9733,
	ILU_SCALE_BELL = 9734,
	ILU_SCALE_BSPLINE = 9735,
	ILU_SCALE_LANCZOS3 = 9736,
	ILU_SCALE_MITCHELL = 9737,
	ILU_INVALID_ENUM = 1281,
	ILU_OUT_OF_MEMORY = 1282,
	ILU_INTERNAL_ERROR = 1284,
	ILU_INVALID_VALUE = 1285,
	ILU_ILLEGAL_OPERATION = 1286,
	ILU_INVALID_PARAM = 1289,
	ILU_PLACEMENT = 1792,
	ILU_LOWER_LEFT = 1793,
	ILU_LOWER_RIGHT = 1794,
	ILU_UPPER_LEFT = 1795,
	ILU_UPPER_RIGHT = 1796,
	ILU_CENTER = 1797,
	ILU_CONVOLUTION_MATRIX = 1808,
	ILU_VERSION_NUM = IL_VERSION_NUM,
	ILU_VENDOR = IL_VENDOR,
	ILU_ENGLISH = 2048,
	ILU_ARABIC = 2049,
	ILU_DUTCH = 2050,
	ILU_JAPANESE = 2051,
	ILU_SPANISH = 2052,
	ILU_GERMAN = 2053,
	ILU_FRENCH = 2054,
}
struct ILinfo
{
	ILuint Id;
	ILubyte* Data;
	ILuint Width;
	ILuint Height;
	ILuint Depth;
	ILubyte Bpp;
	ILuint SizeOfData;
	ILenum Format;
	ILenum Type;
	ILenum Origin;
	ILubyte* Palette;
	ILenum PalType;
	ILuint PalSize;
	ILenum CubeFlags;
	ILuint NumNext;
	ILuint NumMips;
	ILuint NumLayers;
}
struct ILpointf
{
	ILfloat x;
	ILfloat y;
}
struct ILpointi
{
	ILint x;
	ILint y;
}
extern (C) nothrow @nogc 
{
	alias da_iluAlienify = ILboolean function();
	alias da_iluBlurAvg = ILboolean function(ILuint);
	alias da_iluBlurGaussian = ILboolean function(ILuint);
	alias da_iluBuildMipmaps = ILboolean function();
	alias da_iluColoursUsed = ILuint function();
	alias da_iluCompareImage = ILboolean function(ILuint);
	alias da_iluContrast = ILboolean function(ILfloat);
	alias da_iluCrop = ILboolean function(ILuint, ILuint, ILuint, ILuint, ILuint, ILuint);
	alias da_iluDeleteImage = void function(ILuint);
	alias da_iluEdgeDetectE = ILboolean function();
	alias da_iluEdgeDetectP = ILboolean function();
	alias da_iluEdgeDetectS = ILboolean function();
	alias da_iluEmboss = ILboolean function();
	alias da_iluEnlargeCanvas = ILboolean function(ILuint, ILuint, ILuint);
	alias da_iluEnlargeImage = ILboolean function(ILfloat, ILfloat, ILfloat);
	alias da_iluEqualize = ILboolean function();
	alias da_iluErrorString = ILconst_string function(ILenum);
	alias da_iluConvolution = ILboolean function(ILint*, ILint, ILint);
	alias da_iluFlipImage = ILboolean function();
	alias da_iluGammaCorrect = ILboolean function(ILfloat);
	alias da_iluGenImage = ILuint function();
	alias da_iluGetImageInfo = void function(ILinfo*);
	alias da_iluGetInteger = ILint function(ILenum);
	alias da_iluGetIntegerv = void function(ILenum, ILint*);
	alias da_iluGetString = ILstring function(ILenum);
	alias da_iluImageParameter = void function(ILenum, ILenum);
	alias da_iluInit = void function();
	alias da_iluInvertAlpha = ILboolean function();
	alias da_iluLoadImage = ILuint function(ILconst_string);
	alias da_iluMirror = ILboolean function();
	alias da_iluNegative = ILboolean function();
	alias da_iluNoisify = ILboolean function(ILclampf);
	alias da_iluPixelize = ILboolean function(ILuint);
	alias da_iluRegionfv = void function(ILpointf*, ILuint);
	alias da_iluRegioniv = void function(ILpointi*, ILuint);
	alias da_iluReplaceColour = ILboolean function(ILubyte, ILubyte, ILubyte, ILfloat);
	alias da_iluRotate = ILboolean function(ILfloat);
	alias da_iluRotate3D = ILboolean function(ILfloat, ILfloat, ILfloat, ILfloat);
	alias da_iluSaturate1f = ILboolean function(ILfloat);
	alias da_iluSaturate4f = ILboolean function(ILfloat, ILfloat, ILfloat, ILfloat);
	alias da_iluScale = ILboolean function(ILuint, ILuint, ILuint);
	alias da_iluScaleAlpha = ILboolean function(ILfloat);
	alias da_iluScaleColours = ILboolean function(ILfloat, ILfloat, ILfloat);
	alias da_iluSetLanguage = ILboolean function(ILenum);
	alias da_iluSharpen = ILboolean function(ILfloat, ILuint);
	alias da_iluSwapColours = ILboolean function();
	alias da_iluWave = ILboolean function(ILfloat);
}
__gshared 
{
	da_iluAlienify iluAlienify;
	da_iluBlurAvg iluBlurAvg;
	da_iluBlurGaussian iluBlurGaussian;
	da_iluBuildMipmaps iluBuildMipmaps;
	da_iluColoursUsed iluColoursUsed;
	da_iluCompareImage iluCompareImage;
	da_iluContrast iluContrast;
	da_iluCrop iluCrop;
	da_iluDeleteImage iluDeleteImage;
	da_iluEdgeDetectE iluEdgeDetectE;
	da_iluEdgeDetectP iluEdgeDetectP;
	da_iluEdgeDetectS iluEdgeDetectS;
	da_iluEmboss iluEmboss;
	da_iluEnlargeCanvas iluEnlargeCanvas;
	da_iluEnlargeImage iluEnlargeImage;
	da_iluEqualize iluEqualize;
	da_iluErrorString iluErrorString;
	da_iluConvolution iluConvolution;
	da_iluFlipImage iluFlipImage;
	da_iluGammaCorrect iluGammaCorrect;
	da_iluGenImage iluGenImage;
	da_iluGetImageInfo iluGetImageInfo;
	da_iluGetInteger iluGetInteger;
	da_iluGetIntegerv iluGetIntegerv;
	da_iluGetString iluGetString;
	da_iluImageParameter iluImageParameter;
	da_iluInit iluInit;
	da_iluInvertAlpha iluInvertAlpha;
	da_iluLoadImage iluLoadImage;
	da_iluMirror iluMirror;
	da_iluNegative iluNegative;
	da_iluNoisify iluNoisify;
	da_iluPixelize iluPixelize;
	da_iluRegionfv iluRegionfv;
	da_iluRegioniv iluRegioniv;
	da_iluReplaceColour iluReplaceColour;
	da_iluRotate iluRotate;
	da_iluRotate3D iluRotate3D;
	da_iluSaturate1f iluSaturate1f;
	da_iluSaturate4f iluSaturate4f;
	da_iluScale iluScale;
	da_iluScaleAlpha iluScaleAlpha;
	da_iluScaleColours iluScaleColours;
	da_iluSetLanguage iluSetLanguage;
	da_iluSharpen iluSharpen;
	da_iluSwapColours iluSwapColours;
	da_iluWave iluWave;
	alias iluColorsUsed = iluColoursUsed;
	alias iluSwapColors = iluSwapColours;
	alias iluReplaceColor = iluReplaceColour;
	alias iluScaleColors = iluScaleColours;
}
class DerelictILULoader : SharedLibLoader
{
	public this()
	{
		super(libNames);
	}
	protected override void loadSymbols();
}
__gshared DerelictILULoader DerelictILU;
shared static this();
