// D import file generated from 'derelict/devil/ilut.d'
module derelict.devil.ilut;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.devil.il;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "ilut.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libILUT.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libILUT.so";
			}
			else
			{
				static assert(0, "Need to implement ILUT libNames for this operating system.");
			}
		}
	}
}
enum : ILenum
{
	ILUT_VERSION_1_7_8 = 1,
	ILUT_VERSION = 178,
	ILUT_OPENGL_BIT = 1,
	ILUT_D3D_BIT = 2,
	ILUT_ALL_ATTRIB_BITS = 1048575,
	ILUT_INVALID_ENUM = 1281,
	ILUT_OUT_OF_MEMORY = 1282,
	ILUT_INVALID_VALUE = 1285,
	ILUT_ILLEGAL_OPERATION = 1286,
	ILUT_INVALID_PARAM = 1289,
	ILUT_COULD_NOT_OPEN_FILE = 1290,
	ILUT_STACK_OVERFLOW = 1294,
	ILUT_STACK_UNDERFLOW = 1295,
	ILUT_BAD_DIMENSIONS = 1297,
	ILUT_NOT_SUPPORTED = 1360,
	ILUT_PALETTE_MODE = 1536,
	ILUT_OPENGL_CONV = 1552,
	ILUT_D3D_MIPLEVELS = 1568,
	ILUT_MAXTEX_WIDTH = 1584,
	ILUT_MAXTEX_HEIGHT = 1585,
	ILUT_MAXTEX_DEPTH = 1586,
	ILUT_GL_USE_S3TC = 1588,
	ILUT_D3D_USE_DXTC = 1588,
	ILUT_GL_GEN_S3TC = 1589,
	ILUT_D3D_GEN_DXTC = 1589,
	ILUT_S3TC_FORMAT = 1797,
	ILUT_DXTC_FORMAT = 1797,
	ILUT_D3D_POOL = 1798,
	ILUT_D3D_ALPHA_KEY_COLOR = 1799,
	ILUT_D3D_ALPHA_KEY_COLOUR = 1799,
	ILUT_FORCE_INTEGER_FORMAT = 1590,
	ILUT_GL_AUTODETECT_TEXTURE_TARGET = 2055,
	ILUT_VERSION_NUM = IL_VERSION_NUM,
	ILUT_VENDOR = IL_VENDOR,
	ILUT_OPENGL = 0,
	ILUT_ALLEGRO = 1,
	ILUT_WIN32 = 2,
	ILUT_DIRECT3D8 = 3,
	ILUT_DIRECT3D9 = 4,
	ILUT_X11 = 5,
	ILUT_DIRECT3D10 = 6,
}
extern (C) 
{
	alias da_ilutDisable = ILboolean function(ILenum);
	alias da_ilutEnable = ILboolean function(ILenum);
	alias da_ilutGetBoolean = ILboolean function(ILenum);
	alias da_ilutGetBooleanv = void function(ILenum, ILboolean*);
	alias da_ilutGetInteger = ILint function(ILenum);
	alias da_ilutGetIntegerv = void function(ILenum, ILint*);
	alias da_ilutGetString = ILstring function(ILenum);
	alias da_ilutInit = void function();
	alias da_ilutIsDisabled = ILboolean function(ILenum);
	alias da_ilutIsEnabled = ILboolean function(ILenum);
	alias da_ilutPopAttrib = void function();
	alias da_ilutPushAttrib = void function(ILuint);
	alias da_ilutSetInteger = void function(ILenum, ILint);
	alias da_ilutRenderer = ILboolean function(ILenum);
	alias da_ilutGLBindTexImage = uint function();
	alias da_ilutGLBindMipmaps = uint function();
	alias da_ilutGLBuildMipmaps = ILboolean function();
	alias da_ilutGLLoadImage = uint function(ILstring FileName);
	alias da_ilutGLScreen = ILboolean function();
	alias da_ilutGLScreenie = ILboolean function();
	alias da_ilutGLSaveImage = ILboolean function(ILstring, uint);
	alias da_ilutGLSetTex = ILboolean function(uint);
	alias da_ilutGLTexImage = ILboolean function(uint);
	alias da_ilutGLSubTex = ILboolean function(uint, ILuint, ILuint);
	version (Windows)
	{
		private import derelict.util.wintypes;
		alias da_ilutConvertToHBitmap = HBITMAP function(HDC hDC);
		alias da_ilutFreePaddedData = void function(ILubyte* Data);
		alias da_ilutGetBmpInfo = void function(BITMAPINFO* Info);
		alias da_ilutGetHPal = HPALETTE function();
		alias da_ilutGetPaddedData = ILubyte* function();
		alias da_ilutGetWinClipboard = ILboolean function();
		alias da_ilutLoadResource = ILboolean function(HINSTANCE hInst, ILint ID, ILstring ResourceType, ILenum Type);
		alias da_ilutSetHBitmap = ILboolean function(HBITMAP Bitmap);
		alias da_ilutSetHPal = ILboolean function(HPALETTE Pal);
		alias da_ilutSetWinClipboard = ILboolean function();
		alias da_ilutWinLoadImage = HBITMAP function(ILstring FileName, HDC hDC);
		alias da_ilutWinLoadUrl = ILboolean function(ILstring Url);
		alias da_ilutWinPrint = ILboolean function(ILuint XPos, ILuint YPos, ILuint Width, ILuint Height, HDC hDC);
		alias da_ilutWinSaveImage = ILboolean function(ILstring FileName, HBITMAP Bitmap);
	}
	version (Linux)
	{
	}
}
__gshared 
{
	da_ilutDisable ilutDisable;
	da_ilutEnable ilutEnable;
	da_ilutGetBoolean ilutGetBoolean;
	da_ilutGetBooleanv ilutGetBooleanv;
	da_ilutGetInteger ilutGetInteger;
	da_ilutGetIntegerv ilutGetIntegerv;
	da_ilutGetString ilutGetString;
	da_ilutInit ilutInit;
	da_ilutIsDisabled ilutIsDisabled;
	da_ilutIsEnabled ilutIsEnabled;
	da_ilutPopAttrib ilutPopAttrib;
	da_ilutPushAttrib ilutPushAttrib;
	da_ilutSetInteger ilutSetInteger;
	da_ilutRenderer ilutRenderer;
	da_ilutGLBindTexImage ilutGLBindTexImage;
	da_ilutGLBindMipmaps ilutGLBindMipmaps;
	da_ilutGLBuildMipmaps ilutGLBuildMipmaps;
	da_ilutGLLoadImage ilutGLLoadImage;
	da_ilutGLScreen ilutGLScreen;
	da_ilutGLScreenie ilutGLScreenie;
	da_ilutGLSaveImage ilutGLSaveImage;
	da_ilutGLSetTex ilutGLSetTex;
	da_ilutGLTexImage ilutGLTexImage;
	da_ilutGLSubTex ilutGLSubTex;
	version (Windows)
	{
		da_ilutConvertToHBitmap ilutConvertToHBitmap;
		da_ilutFreePaddedData ilutFreePaddedData;
		da_ilutGetBmpInfo ilutGetBmpInfo;
		da_ilutGetHPal ilutGetHPal;
		da_ilutGetPaddedData ilutGetPaddedData;
		da_ilutGetWinClipboard ilutGetWinClipboard;
		da_ilutLoadResource ilutLoadResource;
		da_ilutSetHBitmap ilutSetHBitmap;
		da_ilutSetHPal ilutSetHPal;
		da_ilutSetWinClipboard ilutSetWinClipboard;
		da_ilutWinLoadImage ilutWinLoadImage;
		da_ilutWinLoadUrl ilutWinLoadUrl;
		da_ilutWinPrint ilutWinPrint;
		da_ilutWinSaveImage ilutWinSaveImage;
	}
}
class DerelictILUTLoader : SharedLibLoader
{
	public this()
	{
		super(libNames);
	}
	protected override void loadSymbols();
}
__gshared DerelictILUTLoader DerelictILUT;
shared static this();
